#include <stdio.h>
#include <stdlib.h>

struct graf
{
    int brojCvorova;
    int** matricaSusjedstva;
};
void dodajGranu(struct graf* g,int x,int y){
    g->matricaSusjedstva[x][y]=1; // ovdje onda ide graf.
}

void UcitajGraf(struct graf* g,char* file)
{
    FILE* f=fopen(file,"r");
    if(f==NULL)
    {
        return;
    }
    int n;
    fscanf(f,"%d",&n);
    g->brojCvorova=n;
    g->matricaSusjedstva=malloc(n*sizeof(int*));
    int i;
    for(i=0;i<n;i++)
    {
        g->matricaSusjedstva[i]=malloc(n*sizeof(int));
        int j;
        for(j=0;j<n;j++)
        {
            (g->matricaSusjedstva)[i][j]=0;
        }
    }
    int usmjeren=0;
    fscanf(f,"%d",&usmjeren);

    while(1)
    {
        int x,y;
        fscanf(f,"%d %d",&x,&y);
        if(x==-1 && y==-1)
            break;

        dodajGranu(g,x,y);

        if(!usmjeren)
        {
            dodajGranu(g,y,x);
        }
    }
}
// Dat je graf i pocetni cvor. Napisati f-ju koja stampa sve cvorove do kojih se moze stici iz cvora start.
void DFS(struct graf* g,int * visited,int start)
{
    if(visited[start]==1)
    {
        return;
    }
    /**printf("%d ",start);**/
    visited[start]=1;
    int i;

    for(i=0;i<g->brojCvorova;i++)
    {
        if(g->matricaSusjedstva[start][i]==1)
        {
			printf("%d ",i);
            DFS(g,visited,i);
        }
    }
}
/** Za vjezbu: Napisati proceduru BFS koja vrsi obilazak grafa po sirini koristeci red.  **/

// Za data dva cvora u grafu provjeriti da li postoji put izmedju njih.
int PostojiPutRec(struct graf* g,int* visited,int start,int end)
{
    if(start==end)
    {
        return 1;
    }
    if(visited[start]==1)
    {
        return 0;
    }

    visited[start]=1;
    int i;
    for(i=0;i<g->brojCvorova;i++)
    {
        if(g->matricaSusjedstva[start][i]==1 && PostojiPutRec(g,visited,i,end))
        {
            return 1;
        }
    }
    return 0;
}

int PostojiPut(struct graf* g,int start,int end)
{
    int* visited=malloc((g->brojCvorova)*sizeof(int));
    int i;
    for(i=0;i<g->brojCvorova;i++)
    {
        visited[i]=0;
    }

    DFS(g,visited,start);

    if(visited[end]==1)
    {
        printf("Postoji put!\n");
    }
    else
    {
        printf("Ne postoji put!\n");
    }
}

// Napisati f-ju koja stampa koliko u neusmjerenom grafu postoji komponenti povezanost. Takodje stampati komponente
void DFSKomponente(struct graf* g,int * visited,int start,int brKmp)
{
    if(visited[start]!=0)
    {
        return;
    }
    /**printf("%d ",start);**/
    visited[start]=brKmp;
    int i;

    for(i=0;i<g->brojCvorova;i++)
    {
        if(g->matricaSusjedstva[start][i]==1)
        {
            DFSKomponente(g,visited,i,brKmp);
        }
    }
}

void KompPovezanosti(struct graf* g)
{
    int* visited=malloc((g->brojCvorova)*sizeof(int));
    int i;
    for(i=0;i<g->brojCvorova;i++)
    {
        visited[i]=0;
    }
    int brKmp=0;
    for(i=0;i<g->brojCvorova;i++)
    {
            if(visited[i]==0)
            {
                brKmp++;
                DFSKomponente(g,visited,i,brKmp);
            }
    }
    printf("Broj komponenti povezanosti je: %d\n",brKmp);
    for(i=0;i<g->brojCvorova;i++)
    {
        printf("%d ",visited[i]);
    }
    printf("\n");
}

/** Za vjezbu: Napisati program koji provjerava da li je dati graf bipartitan. **/
int main()
{
    struct graf g;
    UcitajGraf(&g,"graf.txt");
    int i,j;
    /*for(i=0;i<g.brojCvorova;i++)
    {
        for(j=0;j<g.brojCvorova;j++)
        {
            printf("%d ",g.matricaSusjedstva[i][j]);
        }
        printf("\n");
    }*/
    int* visited=malloc((g.brojCvorova)*sizeof(int));
    for(i=0;i<g.brojCvorova;i++)
    {
        visited[i]=0;
    }
    DFS(&g,visited,0);
    PostojiPut(&g,0,4);
    KompPovezanosti(&g);
    return 0;
}
